// Populate the sidebar
//
// This is a script, and not included directly in the page, to control the total size of the book.
// The TOC contains an entry for each page, so if each page includes a copy of the TOC,
// the total size of the page becomes O(n**2).
class MDBookSidebarScrollbox extends HTMLElement {
    constructor() {
        super();
    }
    connectedCallback() {
        // Modify TOC to support external links
        var toc = '<ol class="chapter"><li class="chapter-item affix "><li class="part-title">👾 Welcome!</li><li class="chapter-item "><a href="index.html">HackTricks</a></li><li class="chapter-item "><a href="welcome/hacktricks-values-and-faq.html">HackTricks Values &amp; FAQ</a></li><li class="chapter-item "><a href="welcome/about-the-author.html">About the author</a></li><li class="chapter-item affix "><li class="part-title">🤩 Generic Methodologies &amp; Resources</li><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-methodology.html">Pentesting Methodology</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/external-recon-methodology/index.html">External Recon Methodology</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="generic-methodologies-and-resources/external-recon-methodology/wide-source-code-search.html">Wide Source Code Search</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/external-recon-methodology/github-leaked-secrets.html">Github Dorks &amp; Leaks</a></li></ol></li><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-network/index.html">Pentesting Network</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-network/dhcpv6.html">DHCPv6</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-network/eigrp-attacks.html">EIGRP Attacks</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-network/glbp-and-hsrp-attacks.html">GLBP &amp; HSRP Attacks</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-network/ids-evasion.html">IDS and IPS Evasion</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-network/lateral-vlan-segmentation-bypass.html">Lateral VLAN Segmentation Bypass</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-network/network-protocols-explained-esp.html">Network Protocols Explained (ESP)</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-network/nmap-summary-esp.html">Nmap Summary (ESP)</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-network/pentesting-ipv6.html">Pentesting IPv6</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-network/webrtc-dos.html">WebRTC DoS</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-network/spoofing-llmnr-nbt-ns-mdns-dns-and-wpad-and-relay-attacks.html">Spoofing LLMNR, NBT-NS, mDNS/DNS and WPAD and Relay Attacks</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-network/spoofing-ssdp-and-upnp-devices.html">Spoofing SSDP and UPnP Devices with EvilSSDP</a></li></ol></li><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-wifi/index.html">Pentesting Wifi</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="generic-methodologies-and-resources/pentesting-wifi/evil-twin-eap-tls.html">Evil Twin EAP-TLS</a></li></ol></li><li class="chapter-item "><a href="generic-methodologies-and-resources/phishing-methodology/index.html">Phishing Methodology</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="generic-methodologies-and-resources/phishing-methodology/clone-a-website.html">Clone a Website</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/phishing-methodology/detecting-phising.html">Detecting Phishing</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/phishing-methodology/phishing-documents.html">Phishing Files &amp; Documents</a></li></ol></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/index.html">Basic Forensic Methodology</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/file-integrity-monitoring.html">Baseline Monitoring</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/anti-forensic-techniques.html">Anti-Forensic Techniques</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/docker-forensics.html">Docker Forensics</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/image-acquisition-and-mount.html">Image Acquisition &amp; Mount</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/linux-forensics.html">Linux Forensics</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/malware-analysis.html">Malware Analysis</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/memory-dump-analysis/index.html">Memory dump analysis</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/memory-dump-analysis/volatility-cheatsheet.html">Volatility - CheatSheet</a></li></ol></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/partitions-file-systems-carving/index.html">Partitions/File Systems/Carving</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/partitions-file-systems-carving/file-data-carving-recovery-tools.html">File/Data Carving &amp; Recovery Tools</a></li></ol></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/pcap-inspection/index.html">Pcap Inspection</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/pcap-inspection/dnscat-exfiltration.html">DNSCat pcap analysis</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/pcap-inspection/suricata-and-iptables-cheatsheet.html">Suricata &amp; Iptables cheatsheet</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/pcap-inspection/usb-keystrokes.html">USB Keystrokes</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/pcap-inspection/wifi-pcap-analysis.html">Wifi Pcap Analysis</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/pcap-inspection/wireshark-tricks.html">Wireshark tricks</a></li></ol></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/specific-software-file-type-tricks/index.html">Specific Software/File-Type Tricks</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/specific-software-file-type-tricks/.pyc.html">Decompile compiled python binaries (exe, elf) - Retreive from .pyc</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/specific-software-file-type-tricks/browser-artifacts.html">Browser Artifacts</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/specific-software-file-type-tricks/desofuscation-vbs-cscript.exe.html">Deofuscation vbs (cscript.exe)</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/specific-software-file-type-tricks/local-cloud-storage.html">Local Cloud Storage</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/specific-software-file-type-tricks/office-file-analysis.html">Office file analysis</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/specific-software-file-type-tricks/pdf-file-analysis.html">PDF File analysis</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/specific-software-file-type-tricks/png-tricks.html">PNG tricks</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/specific-software-file-type-tricks/video-and-audio-file-analysis.html">Video and Audio file analysis</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/specific-software-file-type-tricks/zips-tricks.html">ZIPs tricks</a></li></ol></li><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/windows-forensics/index.html">Windows Artifacts</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="generic-methodologies-and-resources/basic-forensic-methodology/windows-forensics/interesting-windows-registry-keys.html">Interesting Windows Registry Keys</a></li></ol></li></ol></li><li class="chapter-item "><a href="generic-methodologies-and-resources/python/index.html">Python Sandbox Escape &amp; Pyscript</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="generic-methodologies-and-resources/python/bypass-python-sandboxes/index.html">Bypass Python sandboxes</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="generic-methodologies-and-resources/python/bypass-python-sandboxes/load_name-load_const-opcode-oob-read.html">LOAD_NAME / LOAD_CONST opcode OOB Read</a></li></ol></li><li class="chapter-item "><a href="generic-methodologies-and-resources/python/class-pollution-pythons-prototype-pollution.html">Class Pollution (Python&#39;s Prototype Pollution)</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/python/python-internal-read-gadgets.html">Python Internal Read Gadgets</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/python/pyscript.html">Pyscript</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/python/venv.html">venv</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/python/web-requests.html">Web Requests</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/python/bruteforce-hash-few-chars.html">Bruteforce hash (few chars)</a></li><li class="chapter-item "><a href="generic-methodologies-and-resources/python/basic-python.html">Basic Python</a></li></ol></li><li class="chapter-item "><a href="generic-methodologies-and-resources/threat-modeling.html">Threat Modeling</a></li><li class="chapter-item affix "><li class="part-title">🧙‍♂️ Generic Hacking</li><li class="chapter-item "><a href="generic-hacking/brute-force.html">Brute Force - CheatSheet</a></li><li class="chapter-item "><a href="generic-hacking/exfiltration.html">Exfiltration</a></li><li class="chapter-item "><a href="generic-hacking/reverse-shells/index.html">Reverse Shells (Linux, Windows, MSFVenom)</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="generic-hacking/reverse-shells/msfvenom.html">MSFVenom - CheatSheet</a></li><li class="chapter-item "><a href="generic-hacking/reverse-shells/windows.html">Reverse Shells - Windows</a></li><li class="chapter-item "><a href="generic-hacking/reverse-shells/linux.html">Reverse Shells - Linux</a></li><li class="chapter-item "><a href="generic-hacking/reverse-shells/expose-local-to-the-internet.html">Expose local to the internet</a></li><li class="chapter-item "><a href="generic-hacking/reverse-shells/full-ttys.html">Full TTYs</a></li></ol></li><li class="chapter-item "><a href="generic-hacking/search-exploits.html">Search Exploits</a></li><li class="chapter-item "><a href="generic-hacking/tunneling-and-port-forwarding.html">Tunneling and Port Forwarding</a></li><li class="chapter-item affix "><li class="part-title">🐧 Linux Hardening</li><li class="chapter-item "><a href="linux-hardening/linux-privilege-escalation-checklist.html">Checklist - Linux Privilege Escalation</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/index.html">Linux Privilege Escalation</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="linux-hardening/privilege-escalation/write-to-root.html">Arbitrary File Write to Root</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/cisco-vmanage.html">Cisco - vmanage</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/containerd-ctr-privilege-escalation.html">Containerd (ctr) Privilege Escalation</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/d-bus-enumeration-and-command-injection-privilege-escalation.html">D-Bus Enumeration &amp; Command Injection Privilege Escalation</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/index.html">Docker Security</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/abusing-docker-socket-for-privilege-escalation.html">Abusing Docker Socket for Privilege Escalation</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/apparmor.html">AppArmor</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/authz-and-authn-docker-access-authorization-plugin.html">AuthZ&amp; AuthN - Docker Access Authorization Plugin</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/cgroups.html">CGroups</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/docker-privileged.html">Docker --privileged</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/docker-breakout-privilege-escalation/index.html">Docker Breakout / Privilege Escalation</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/docker-breakout-privilege-escalation/release_agent-exploit-relative-paths-to-pids.html">release_agent exploit - Relative Paths to PIDs</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/docker-breakout-privilege-escalation/docker-release_agent-cgroups-escape.html">Docker release_agent cgroups escape</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/docker-breakout-privilege-escalation/sensitive-mounts.html">Sensitive Mounts</a></li></ol></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/namespaces/index.html">Namespaces</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/namespaces/cgroup-namespace.html">CGroup Namespace</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/namespaces/ipc-namespace.html">IPC Namespace</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/namespaces/pid-namespace.html">PID Namespace</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/namespaces/mount-namespace.html">Mount Namespace</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/namespaces/network-namespace.html">Network Namespace</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/namespaces/time-namespace.html">Time Namespace</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/namespaces/user-namespace.html">User Namespace</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/namespaces/uts-namespace.html">UTS Namespace</a></li></ol></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/seccomp.html">Seccomp</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/docker-security/weaponizing-distroless.html">Weaponizing Distroless</a></li></ol></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/escaping-from-limited-bash.html">Escaping from Jails</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/euid-ruid-suid.html">euid, ruid, suid</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/interesting-groups-linux-pe/index.html">Interesting Groups - Linux Privesc</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="linux-hardening/privilege-escalation/interesting-groups-linux-pe/lxd-privilege-escalation.html">lxd/lxc Group - Privilege escalation</a></li></ol></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/logstash.html">Logstash</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/ld.so.conf-example.html">ld.so privesc exploit example</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/linux-active-directory.html">Linux Active Directory</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/linux-capabilities.html">Linux Capabilities</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/nfs-no_root_squash-misconfiguration-pe.html">NFS no_root_squash/no_all_squash misconfiguration PE</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/electron-cef-chromium-debugger-abuse.html">Node inspector/CEF debug abuse</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/payloads-to-execute.html">Payloads to execute</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/runc-privilege-escalation.html">RunC Privilege Escalation</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/selinux.html">SELinux</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/socket-command-injection.html">Socket Command Injection</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/splunk-lpe-and-persistence.html">Splunk LPE and Persistence</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/ssh-forward-agent-exploitation.html">SSH Forward Agent exploitation</a></li><li class="chapter-item "><a href="linux-hardening/privilege-escalation/wildcards-spare-tricks.html">Wildcards Spare tricks</a></li></ol></li><li class="chapter-item "><a href="linux-hardening/useful-linux-commands.html">Useful Linux Commands</a></li><li class="chapter-item "><a href="linux-hardening/bypass-bash-restrictions/index.html">Bypass Linux Restrictions</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="linux-hardening/bypass-bash-restrictions/bypass-fs-protections-read-only-no-exec-distroless/index.html">Bypass FS protections: read-only / no-exec / Distroless</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="linux-hardening/bypass-bash-restrictions/bypass-fs-protections-read-only-no-exec-distroless/ddexec.html">DDexec / EverythingExec</a></li></ol></li></ol></li><li class="chapter-item "><a href="linux-hardening/linux-environment-variables.html">Linux Environment Variables</a></li><li class="chapter-item "><a href="linux-hardening/linux-post-exploitation/index.html">Linux Post-Exploitation</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="linux-hardening/linux-post-exploitation/pam-pluggable-authentication-modules.html">PAM - Pluggable Authentication Modules</a></li></ol></li><li class="chapter-item "><a href="linux-hardening/freeipa-pentesting.html">FreeIPA Pentesting</a></li><li class="chapter-item affix "><li class="part-title">🍏 MacOS Hardening</li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/index.html">macOS Security &amp; Privilege Escalation</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-apps-inspecting-debugging-and-fuzzing/index.html">macOS Apps - Inspecting, debugging and Fuzzing</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-apps-inspecting-debugging-and-fuzzing/objects-in-memory.html">Objects in memory</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-apps-inspecting-debugging-and-fuzzing/introduction-to-x64.html">Introduction to x64</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-apps-inspecting-debugging-and-fuzzing/arm64-basic-assembly.html">Introduction to ARM64v8</a></li></ol></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-applefs.html">macOS AppleFS</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-bypassing-firewalls.html">macOS Bypassing Firewalls</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-defensive-apps.html">macOS Defensive Apps</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-gcd-grand-central-dispatch.html">macOS GCD - Grand Central Dispatch</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/mac-os-architecture/index.html">macOS Kernel &amp; System Extensions</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/mac-os-architecture/macos-iokit.html">macOS IOKit</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/mac-os-architecture/macos-kernel-extensions.html">macOS Kernel Extensions &amp; Debugging</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/mac-os-architecture/macos-kernel-vulnerabilities.html">macOS Kernel Vulnerabilities</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/mac-os-architecture/macos-system-extensions.html">macOS System Extensions</a></li></ol></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-protocols.html">macOS Network Services &amp; Protocols</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-file-extension-apps.html">macOS File Extension &amp; URL scheme app handlers</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-files-folders-and-binaries/index.html">macOS Files, Folders, Binaries &amp; Memory</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-files-folders-and-binaries/macos-bundles.html">macOS Bundles</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-files-folders-and-binaries/macos-installers-abuse.html">macOS Installers Abuse</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-files-folders-and-binaries/macos-memory-dumping.html">macOS Memory Dumping</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-files-folders-and-binaries/macos-sensitive-locations.html">macOS Sensitive Locations &amp; Interesting Daemons</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-files-folders-and-binaries/universal-binaries-and-mach-o-format.html">macOS Universal binaries &amp; Mach-O Format</a></li></ol></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-basic-objective-c.html">macOS Objective-C</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-privilege-escalation.html">macOS Privilege Escalation</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/index.html">macOS Process Abuse</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-dirty-nib.html">macOS Dirty NIB</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-chromium-injection.html">macOS Chromium Injection</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-electron-applications-injection.html">macOS Electron Applications Injection</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-function-hooking.html">macOS Function Hooking</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-ipc-inter-process-communication/index.html">macOS IPC - Inter Process Communication</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-ipc-inter-process-communication/macos-mig-mach-interface-generator.html">macOS MIG - Mach Interface Generator</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-ipc-inter-process-communication/macos-xpc/index.html">macOS XPC</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-ipc-inter-process-communication/macos-xpc/macos-xpc-authorization.html">macOS XPC Authorization</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-ipc-inter-process-communication/macos-xpc/macos-xpc-connecting-process-check/index.html">macOS XPC Connecting Process Check</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-ipc-inter-process-communication/macos-xpc/macos-xpc-connecting-process-check/macos-pid-reuse.html">macOS PID Reuse</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-ipc-inter-process-communication/macos-xpc/macos-xpc-connecting-process-check/macos-xpc_connection_get_audit_token-attack.html">macOS xpc_connection_get_audit_token Attack</a></li></ol></li></ol></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-ipc-inter-process-communication/macos-thread-injection-via-task-port.html">macOS Thread Injection via Task port</a></li></ol></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-java-apps-injection.html">macOS Java Applications Injection</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-library-injection/index.html">macOS Library Injection</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-library-injection/macos-dyld-hijacking-and-dyld_insert_libraries.html">macOS Dyld Hijacking &amp; DYLD_INSERT_LIBRARIES</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-library-injection/macos-dyld-process.html">macOS Dyld Process</a></li></ol></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-perl-applications-injection.html">macOS Perl Applications Injection</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-python-applications-injection.html">macOS Python Applications Injection</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-ruby-applications-injection.html">macOS Ruby Applications Injection</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-proces-abuse/macos-.net-applications-injection.html">macOS .Net Applications Injection</a></li></ol></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/index.html">macOS Security Protections</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-gatekeeper.html">macOS Gatekeeper / Quarantine / XProtect</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-launch-environment-constraints.html">macOS Launch/Environment Constraints &amp; Trust Cache</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-sandbox/index.html">macOS Sandbox</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-sandbox/macos-default-sandbox-debug.html">macOS Default Sandbox Debug</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-sandbox/macos-sandbox-debug-and-bypass/index.html">macOS Sandbox Debug &amp; Bypass</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-sandbox/macos-sandbox-debug-and-bypass/macos-office-sandbox-bypasses.html">macOS Office Sandbox Bypasses</a></li></ol></li></ol></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-authorizations-db-and-authd.html">macOS Authorizations DB &amp; Authd</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-sip.html">macOS SIP</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-tcc/index.html">macOS TCC</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-tcc/macos-apple-events.html">macOS Apple Events</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-tcc/macos-tcc-bypasses/index.html">macOS TCC Bypasses</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-tcc/macos-tcc-bypasses/macos-apple-scripts.html">macOS Apple Scripts</a></li></ol></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-tcc/macos-tcc-payloads.html">macOS TCC Payloads</a></li></ol></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-dangerous-entitlements.html">macOS Dangerous Entitlements &amp; TCC perms</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-amfi-applemobilefileintegrity.html">macOS - AMFI - AppleMobileFileIntegrity</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-macf-mandatory-access-control-framework.html">macOS MACF - Mandatory Access Control Framework</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-code-signing.html">macOS Code Signing</a></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-fs-tricks/index.html">macOS FS Tricks</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-security-protections/macos-fs-tricks/macos-xattr-acls-extra-stuff.html">macOS xattr-acls extra stuff</a></li></ol></li></ol></li><li class="chapter-item "><a href="macos-hardening/macos-security-and-privilege-escalation/macos-users.html">macOS Users &amp; External Accounts</a></li></ol></li><li class="chapter-item "><a href="macos-hardening/macos-red-teaming/index.html">macOS Red Teaming</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-red-teaming/macos-mdm/index.html">macOS MDM</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="macos-hardening/macos-red-teaming/macos-mdm/enrolling-devices-in-other-organisations.html">Enrolling Devices in Other Organisations</a></li><li class="chapter-item "><a href="macos-hardening/macos-red-teaming/macos-mdm/macos-serial-number.html">macOS Serial Number</a></li></ol></li><li class="chapter-item "><a href="macos-hardening/macos-red-teaming/macos-keychain.html">macOS Keychain</a></li></ol></li><li class="chapter-item "><a href="macos-hardening/macos-useful-commands.html">macOS Useful Commands</a></li><li class="chapter-item "><a href="macos-hardening/macos-auto-start-locations.html">macOS Auto Start</a></li><li class="chapter-item affix "><li class="part-title">🪟 Windows Hardening</li><li class="chapter-item "><a href="windows-hardening/checklist-windows-privilege-escalation.html">Checklist - Local Windows Privilege Escalation</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/index.html">Windows Local Privilege Escalation</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/privilege-escalation-abusing-tokens.html">Abusing Tokens</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/access-tokens.html">Access Tokens</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/acls-dacls-sacls-aces.html">ACLs - DACLs/SACLs/ACEs</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/appenddata-addsubdirectory-permission-over-service-registry.html">AppendData/AddSubdirectory permission over service registry</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/create-msi-with-wix.html">Create MSI with WIX</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/com-hijacking.html">COM Hijacking</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/dll-hijacking/index.html">Dll Hijacking</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/dll-hijacking/writable-sys-path-+dll-hijacking-privesc.html">Writable Sys Path +Dll Hijacking Privesc</a></li></ol></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/dpapi-extracting-passwords.html">DPAPI - Extracting Passwords</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/from-high-integrity-to-system-with-name-pipes.html">From High Integrity to SYSTEM with Name Pipes</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/integrity-levels.html">Integrity Levels</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/juicypotato.html">JuicyPotato</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/leaked-handle-exploitation.html">Leaked Handle Exploitation</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/msi-wrapper.html">MSI Wrapper</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/named-pipe-client-impersonation.html">Named Pipe Client Impersonation</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/privilege-escalation-with-autorun-binaries.html">Privilege Escalation with Autoruns</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/roguepotato-and-printspoofer.html">RoguePotato, PrintSpoofer, SharpEfsPotato, GodPotato</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/sedebug-+-seimpersonate-copy-token.html">SeDebug + SeImpersonate copy token</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/seimpersonate-from-high-to-system.html">SeImpersonate from High To System</a></li><li class="chapter-item "><a href="windows-hardening/windows-local-privilege-escalation/windows-c-payloads.html">Windows C Payloads</a></li></ol></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/index.html">Active Directory Methodology</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/acl-persistence-abuse/index.html">Abusing Active Directory ACLs/ACEs</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/acl-persistence-abuse/shadow-credentials.html">Shadow Credentials</a></li></ol></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/ad-certificates/index.html">AD Certificates</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/ad-certificates/account-persistence.html">AD CS Account Persistence</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/ad-certificates/domain-escalation.html">AD CS Domain Escalation</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/ad-certificates/domain-persistence.html">AD CS Domain Persistence</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/ad-certificates/certificate-theft.html">AD CS Certificate Theft</a></li></ol></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/ad-information-in-printers.html">AD information in printers</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/ad-dns-records.html">AD DNS Records</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/asreproast.html">ASREPRoast</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/bloodhound.html">BloodHound &amp; Other AD Enum Tools</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/constrained-delegation.html">Constrained Delegation</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/custom-ssp.html">Custom SSP</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/dcshadow.html">DCShadow</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/dcsync.html">DCSync</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/diamond-ticket.html">Diamond Ticket</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/dsrm-credentials.html">DSRM Credentials</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/external-forest-domain-oneway-inbound.html">External Forest Domain - OneWay (Inbound) or bidirectional</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/external-forest-domain-one-way-outbound.html">External Forest Domain - One-Way (Outbound)</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/golden-ticket.html">Golden Ticket</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/kerberoast.html">Kerberoast</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/kerberos-authentication.html">Kerberos Authentication</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/kerberos-double-hop-problem.html">Kerberos Double Hop Problem</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/laps.html">LAPS</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/abusing-ad-mssql.html">MSSQL AD Abuse</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/over-pass-the-hash-pass-the-key.html">Over Pass the Hash/Pass the Key</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/pass-the-ticket.html">Pass the Ticket</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/password-spraying.html">Password Spraying / Brute Force</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/printnightmare.html">PrintNightmare</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/printers-spooler-service-abuse.html">Force NTLM Privileged Authentication</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/privileged-groups-and-token-privileges.html">Privileged Groups</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/rdp-sessions-abuse.html">RDP Sessions Abuse</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/resource-based-constrained-delegation.html">Resource-based Constrained Delegation</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/security-descriptors.html">Security Descriptors</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/sid-history-injection.html">SID-History Injection</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/silver-ticket.html">Silver Ticket</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/skeleton-key.html">Skeleton Key</a></li><li class="chapter-item "><a href="windows-hardening/active-directory-methodology/unconstrained-delegation.html">Unconstrained Delegation</a></li></ol></li><li class="chapter-item "><a href="windows-hardening/authentication-credentials-uac-and-efs/index.html">Windows Security Controls</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="windows-hardening/authentication-credentials-uac-and-efs/uac-user-account-control.html">UAC - User Account Control</a></li></ol></li><li class="chapter-item "><a href="windows-hardening/ntlm/index.html">NTLM</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="windows-hardening/ntlm/places-to-steal-ntlm-creds.html">Places to steal NTLM creds</a></li></ol></li><li class="chapter-item "><a href="windows-hardening/lateral-movement/index.html">Lateral Movement</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="windows-hardening/lateral-movement/atexec.html">AtExec / SchtasksExec</a></li><li class="chapter-item "><a href="windows-hardening/lateral-movement/dcom-exec.html">DCOM Exec</a></li><li class="chapter-item "><a href="windows-hardening/lateral-movement/psexec-and-winexec.html">PsExec/Winexec/ScExec</a></li><li class="chapter-item "><a href="windows-hardening/lateral-movement/smbexec.html">SmbExec/ScExec</a></li><li class="chapter-item "><a href="windows-hardening/lateral-movement/winrm.html">WinRM</a></li><li class="chapter-item "><a href="windows-hardening/lateral-movement/wmiexec.html">WmiExec</a></li></ol></li><li class="chapter-item "><div>Pivoting to the Cloud$$external:https://cloud.hacktricks.wiki/en/pentesting-cloud/azure-security/az-lateral-movement-cloud-on-prem/index.html$$</div></li><li class="chapter-item "><a href="windows-hardening/stealing-credentials/index.html">Stealing Windows Credentials</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="windows-hardening/stealing-credentials/credentials-protections.html">Windows Credentials Protections</a></li><li class="chapter-item "><a href="windows-hardening/stealing-credentials/credentials-mimikatz.html">Mimikatz</a></li><li class="chapter-item "><a href="windows-hardening/stealing-credentials/wts-impersonator.html">WTS Impersonator</a></li></ol></li><li class="chapter-item "><a href="windows-hardening/basic-cmd-for-pentesters.html">Basic Win CMD for Pentesters</a></li><li class="chapter-item "><a href="windows-hardening/basic-powershell-for-pentesters/index.html">Basic PowerShell for Pentesters</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="windows-hardening/basic-powershell-for-pentesters/powerview.html">PowerView/SharpView</a></li></ol></li><li class="chapter-item "><a href="windows-hardening/av-bypass.html">Antivirus (AV) Bypass</a></li><li class="chapter-item "><a href="windows-hardening/cobalt-strike.html">Cobalt Strike</a></li><li class="chapter-item affix "><li class="part-title">📱 Mobile Pentesting</li><li class="chapter-item "><a href="mobile-pentesting/android-checklist.html">Android APK Checklist</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/index.html">Android Applications Pentesting</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/android-applications-basics.html">Android Applications Basics</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/android-task-hijacking.html">Android Task Hijacking</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/adb-commands.html">ADB Commands</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/apk-decompilers.html">APK decompilers</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/avd-android-virtual-device.html">AVD - Android Virtual Device</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/bypass-biometric-authentication-android.html">Bypass Biometric Authentication (Android)</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/content-protocol.html">content:// protocol</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/drozer-tutorial/index.html">Drozer Tutorial</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/drozer-tutorial/exploiting-content-providers.html">Exploiting Content Providers</a></li></ol></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/exploiting-a-debuggeable-applciation.html">Exploiting a debuggeable application</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/frida-tutorial/index.html">Frida Tutorial</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/frida-tutorial/frida-tutorial-1.html">Frida Tutorial 1</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/frida-tutorial/frida-tutorial-2.html">Frida Tutorial 2</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/frida-tutorial/owaspuncrackable-1.html">Frida Tutorial 3</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/frida-tutorial/objection-tutorial.html">Objection Tutorial</a></li></ol></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/google-ctf-2018-shall-we-play-a-game.html">Google CTF 2018 - Shall We Play a Game?</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/install-burp-certificate.html">Install Burp Certificate</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/intent-injection.html">Intent Injection</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/make-apk-accept-ca-certificate.html">Make APK Accept CA Certificate</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/manual-deobfuscation.html">Manual DeObfuscation</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/react-native-application.html">React Native Application</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/reversing-native-libraries.html">Reversing Native Libraries</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/smali-changes.html">Smali - Decompiling/[Modifying]/Compiling</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/spoofing-your-location-in-play-store.html">Spoofing your location in Play Store</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/tapjacking.html">Tapjacking</a></li><li class="chapter-item "><a href="mobile-pentesting/android-app-pentesting/webview-attacks.html">Webview Attacks</a></li></ol></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting-checklist.html">iOS Pentesting Checklist</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/index.html">iOS Pentesting</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/ios-app-extensions.html">iOS App Extensions</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/ios-basics.html">iOS Basics</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/basic-ios-testing-operations.html">iOS Basic Testing Operations</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/burp-configuration-for-ios.html">iOS Burp Suite Configuration</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/ios-custom-uri-handlers-deeplinks-custom-schemes.html">iOS Custom URI Handlers / Deeplinks / Custom Schemes</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/extracting-entitlements-from-compiled-application.html">iOS Extracting Entitlements From Compiled Application</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/frida-configuration-in-ios.html">iOS Frida Configuration</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/ios-hooking-with-objection.html">iOS Hooking With Objection</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/ios-protocol-handlers.html">iOS Protocol Handlers</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/ios-serialisation-and-encoding.html">iOS Serialisation and Encoding</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/ios-testing-environment.html">iOS Testing Environment</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/ios-uiactivity-sharing.html">iOS UIActivity Sharing</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/ios-universal-links.html">iOS Universal Links</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/ios-uipasteboard.html">iOS UIPasteboard</a></li><li class="chapter-item "><a href="mobile-pentesting/ios-pentesting/ios-webviews.html">iOS WebViews</a></li></ol></li><li class="chapter-item "><a href="mobile-pentesting/cordova-apps.html">Cordova Apps</a></li><li class="chapter-item "><a href="mobile-pentesting/xamarin-apps.html">Xamarin Apps</a></li><li class="chapter-item affix "><li class="part-title">👽 Network Services Pentesting</li><li class="chapter-item "><a href="network-services-pentesting/pentesting-jdwp-java-debug-wire-protocol.html">Pentesting JDWP - Java Debug Wire Protocol</a></li><li class="chapter-item "><div>Pentesting Printers$$external:http://hacking-printers.net/wiki/index.php/Main_Page$$</div></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-sap.html">Pentesting SAP</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-voip/index.html">Pentesting VoIP</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/pentesting-voip/basic-voip-protocols/index.html">Basic VoIP Protocols</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/pentesting-voip/basic-voip-protocols/sip-session-initiation-protocol.html">SIP (Session Initiation Protocol)</a></li></ol></li></ol></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-remote-gdbserver.html">Pentesting Remote GdbServer</a></li><li class="chapter-item "><a href="network-services-pentesting/7-tcp-udp-pentesting-echo.html">7/tcp/udp - Pentesting Echo</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-ftp/index.html">21 - Pentesting FTP</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/pentesting-ftp/ftp-bounce-attack.html">FTP Bounce attack - Scan</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-ftp/ftp-bounce-download-2oftp-file.html">FTP Bounce - Download 2ºFTP file</a></li></ol></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-ssh.html">22 - Pentesting SSH/SFTP</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-telnet.html">23 - Pentesting Telnet</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-smtp/index.html">25,465,587 - Pentesting SMTP/s</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/pentesting-smtp/smtp-smuggling.html">SMTP Smuggling</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-smtp/smtp-commands.html">SMTP - Commands</a></li></ol></li><li class="chapter-item "><a href="network-services-pentesting/43-pentesting-whois.html">43 - Pentesting WHOIS</a></li><li class="chapter-item "><a href="network-services-pentesting/49-pentesting-tacacs+.html">49 - Pentesting TACACS+</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-dns.html">53 - Pentesting DNS</a></li><li class="chapter-item "><a href="network-services-pentesting/69-udp-tftp.html">69/UDP TFTP/Bittorrent-tracker</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-finger.html">79 - Pentesting Finger</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/index.html">80,443 - Pentesting Web Methodology</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/403-and-401-bypasses.html">403 &amp; 401 Bypasses</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/aem-adobe-experience-cloud.html">AEM - Adobe Experience Cloud</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/angular.html">Angular</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/apache.html">Apache</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/artifactory-hacking-guide.html">Artifactory Hacking guide</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/bolt-cms.html">Bolt CMS</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/buckets/index.html">Buckets</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/buckets/firebase-database.html">Firebase Database</a></li></ol></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/cgi.html">CGI</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/dotnetnuke-dnn.html">DotNetNuke (DNN)</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/drupal/index.html">Drupal</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/drupal/drupal-rce.html">Drupal RCE</a></li></ol></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/electron-desktop-apps/index.html">Electron Desktop Apps</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/electron-desktop-apps/electron-contextisolation-rce-via-preload-code.html">Electron contextIsolation RCE via preload code</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/electron-desktop-apps/electron-contextisolation-rce-via-electron-internal-code.html">Electron contextIsolation RCE via Electron internal code</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/electron-desktop-apps/electron-contextisolation-rce-via-ipc.html">Electron contextIsolation RCE via IPC</a></li></ol></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/flask.html">Flask</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/nextjs.html">NextJS</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/nodejs-express.html">NodeJS Express</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/git.html">Git</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/golang.html">Golang</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/gwt-google-web-toolkit.html">GWT - Google Web Toolkit</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/grafana.html">Grafana</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/graphql.html">GraphQL</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/h2-java-sql-database.html">H2 - Java SQL database</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/iis-internet-information-services.html">IIS - Internet Information Services</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/imagemagick-security.html">ImageMagick Security</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/jboss.html">JBOSS</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/jira.html">Jira &amp; Confluence</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/joomla.html">Joomla</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/jsp.html">JSP</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/laravel.html">Laravel</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/moodle.html">Moodle</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/nginx.html">Nginx</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/nextjs-1.html">NextJS</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/index.html">PHP Tricks</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/index.html">PHP - Useful Functions &amp; disable_functions/open_basedir bypass</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-bypass-php-fpm-fastcgi.html">disable_functions bypass - php-fpm/FastCGI</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-bypass-dl-function.html">disable_functions bypass - dl function</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-bypass-php-7.0-7.4-nix-only.html">disable_functions bypass - PHP 7.0-7.4 (-nix only)</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-bypass-imagick-less-than-3.3.0-php-greater-than-5.4-exploit.html">disable_functions bypass - Imagick &lt;= 3.3.0 PHP &gt;= 5.4 Exploit</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-php-5.x-shellshock-exploit.html">disable_functions - PHP 5.x Shellshock Exploit</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-php-5.2.4-ioncube-extension-exploit.html">disable_functions - PHP 5.2.4 ionCube extension Exploit</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-bypass-php-less-than-5.2.9-on-windows.html">disable_functions bypass - PHP &lt;= 5.2.9 on windows</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-bypass-php-5.2.4-and-5.2.5-php-curl.html">disable_functions bypass - PHP 5.2.4 and 5.2.5 PHP cURL</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-bypass-php-safe_mode-bypass-via-proc_open-and-custom-environment-exploit.html">disable_functions bypass - PHP safe_mode bypass via proc_open() and custom environment Exploit</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-bypass-php-perl-extension-safe_mode-bypass-exploit.html">disable_functions bypass - PHP Perl Extension Safe_mode Bypass Exploit</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-bypass-php-5.2.3-win32std-ext-protections-bypass.html">disable_functions bypass - PHP 5.2.3 - Win32std ext Protections Bypass</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-bypass-php-5.2-fopen-exploit.html">disable_functions bypass - PHP 5.2 - FOpen Exploit</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-bypass-via-mem.html">disable_functions bypass - via mem</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-bypass-mod_cgi.html">disable_functions bypass - mod_cgi</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-useful-functions-disable_functions-open_basedir-bypass/disable_functions-bypass-php-4-greater-than-4.2.0-php-5-pcntl_exec.html">disable_functions bypass - PHP 4 &gt;= 4.2.0, PHP 5 pcntl_exec</a></li></ol></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-rce-abusing-object-creation-new-usd_get-a-usd_get-b.html">PHP - RCE abusing object creation: new $_GET["a"]($_GET["b"])</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/php-tricks-esp/php-ssrf.html">PHP SSRF</a></li></ol></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/prestashop.html">PrestaShop</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/python.html">Python</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/rocket-chat.html">Rocket Chat</a></li><li class="chapter-item "><div>Special HTTP headers$$external:network-services-pentesting/pentesting-web/special-http-headers.md$$</div></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/code-review-tools.html">Source code Review / SAST Tools</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/spring-actuators.html">Spring Actuators</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/symphony.html">Symfony</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/tomcat/index.html">Tomcat</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/uncovering-cloudflare.html">Uncovering CloudFlare</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/vmware-esx-vcenter....html">VMWare (ESX, VCenter...)</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/web-api-pentesting.html">Web API Pentesting</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/put-method-webdav.html">WebDav</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/werkzeug.html">Werkzeug / Flask Debug</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-web/wordpress.html">Wordpress</a></li></ol></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-kerberos-88/index.html">88tcp/udp - Pentesting Kerberos</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/pentesting-kerberos-88/harvesting-tickets-from-windows.html">Harvesting tickets from Windows</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-kerberos-88/harvesting-tickets-from-linux.html">Harvesting tickets from Linux</a></li></ol></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-pop.html">110,995 - Pentesting POP</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-rpcbind.html">111/TCP/UDP - Pentesting Portmapper</a></li><li class="chapter-item "><a href="network-services-pentesting/113-pentesting-ident.html">113 - Pentesting Ident</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-ntp.html">123/udp - Pentesting NTP</a></li><li class="chapter-item "><a href="network-services-pentesting/135-pentesting-msrpc.html">135, 593 - Pentesting MSRPC</a></li><li class="chapter-item "><a href="network-services-pentesting/137-138-139-pentesting-netbios.html">137,138,139 - Pentesting NetBios</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-smb/index.html">139,445 - Pentesting SMB</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/pentesting-smb/rpcclient-enumeration.html">rpcclient enumeration</a></li></ol></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-imap.html">143,993 - Pentesting IMAP</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-snmp/index.html">161,162,10161,10162/udp - Pentesting SNMP</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/pentesting-snmp/cisco-snmp.html">Cisco SNMP</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-snmp/snmp-rce.html">SNMP RCE</a></li></ol></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-irc.html">194,6667,6660-7000 - Pentesting IRC</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-264-check-point-firewall-1.html">264 - Pentesting Check Point FireWall-1</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-ldap.html">389, 636, 3268, 3269 - Pentesting LDAP</a></li><li class="chapter-item "><a href="network-services-pentesting/ipsec-ike-vpn-pentesting.html">500/udp - Pentesting IPsec/IKE VPN</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-modbus.html">502 - Pentesting Modbus</a></li><li class="chapter-item "><a href="network-services-pentesting/512-pentesting-rexec.html">512 - Pentesting Rexec</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-rlogin.html">513 - Pentesting Rlogin</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-rsh.html">514 - Pentesting Rsh</a></li><li class="chapter-item "><a href="network-services-pentesting/515-pentesting-line-printer-daemon-lpd.html">515 - Pentesting Line Printer Daemon (LPD)</a></li><li class="chapter-item "><a href="network-services-pentesting/584-pentesting-afp.html">548 - Pentesting Apple Filing Protocol (AFP)</a></li><li class="chapter-item "><a href="network-services-pentesting/554-8554-pentesting-rtsp.html">554,8554 - Pentesting RTSP</a></li><li class="chapter-item "><a href="network-services-pentesting/623-udp-ipmi.html">623/UDP/TCP - IPMI</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-631-internet-printing-protocol-ipp.html">631 - Internet Printing Protocol(IPP)</a></li><li class="chapter-item "><a href="network-services-pentesting/700-pentesting-epp.html">700 - Pentesting EPP</a></li><li class="chapter-item "><a href="network-services-pentesting/873-pentesting-rsync.html">873 - Pentesting Rsync</a></li><li class="chapter-item "><a href="network-services-pentesting/1026-pentesting-rusersd.html">1026 - Pentesting Rusersd</a></li><li class="chapter-item "><a href="network-services-pentesting/1080-pentesting-socks.html">1080 - Pentesting Socks</a></li><li class="chapter-item "><a href="network-services-pentesting/1099-pentesting-java-rmi.html">1098/1099/1050 - Pentesting Java RMI - RMI-IIOP</a></li><li class="chapter-item "><a href="network-services-pentesting/1414-pentesting-ibmmq.html">1414 - Pentesting IBM MQ</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-mssql-microsoft-sql-server/index.html">1433 - Pentesting MSSQL - Microsoft SQL Server</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/pentesting-mssql-microsoft-sql-server/types-of-mssql-users.html">Types of MSSQL Users</a></li></ol></li><li class="chapter-item "><a href="network-services-pentesting/1521-1522-1529-pentesting-oracle-listener.html">1521,1522-1529 - Pentesting Oracle TNS Listener</a></li><li class="chapter-item "><a href="network-services-pentesting/1723-pentesting-pptp.html">1723 - Pentesting PPTP</a></li><li class="chapter-item "><a href="network-services-pentesting/1883-pentesting-mqtt-mosquitto.html">1883 - Pentesting MQTT (Mosquitto)</a></li><li class="chapter-item "><a href="network-services-pentesting/nfs-service-pentesting.html">2049 - Pentesting NFS Service</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-compaq-hp-insight-manager.html">2301,2381 - Pentesting Compaq/HP Insight Manager</a></li><li class="chapter-item "><a href="network-services-pentesting/2375-pentesting-docker.html">2375, 2376 Pentesting Docker</a></li><li class="chapter-item "><a href="network-services-pentesting/3128-pentesting-squid.html">3128 - Pentesting Squid</a></li><li class="chapter-item "><a href="network-services-pentesting/3260-pentesting-iscsi.html">3260 - Pentesting ISCSI</a></li><li class="chapter-item "><a href="network-services-pentesting/3299-pentesting-saprouter.html">3299 - Pentesting SAPRouter</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-mysql.html">3306 - Pentesting Mysql</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-rdp.html">3389 - Pentesting RDP</a></li><li class="chapter-item "><a href="network-services-pentesting/3632-pentesting-distcc.html">3632 - Pentesting distcc</a></li><li class="chapter-item "><a href="network-services-pentesting/3690-pentesting-subversion-svn-server.html">3690 - Pentesting Subversion (svn server)</a></li><li class="chapter-item "><a href="network-services-pentesting/3702-udp-pentesting-ws-discovery.html">3702/UDP - Pentesting WS-Discovery</a></li><li class="chapter-item "><a href="network-services-pentesting/4369-pentesting-erlang-port-mapper-daemon-epmd.html">4369 - Pentesting Erlang Port Mapper Daemon (epmd)</a></li><li class="chapter-item "><a href="network-services-pentesting/4786-cisco-smart-install.html">4786 - Cisco Smart Install</a></li><li class="chapter-item "><a href="network-services-pentesting/4840-pentesting-opc-ua.html">4840 - OPC Unified Architecture</a></li><li class="chapter-item "><a href="network-services-pentesting/5000-pentesting-docker-registry.html">5000 - Pentesting Docker Registry</a></li><li class="chapter-item "><a href="network-services-pentesting/5353-udp-multicast-dns-mdns.html">5353/UDP Multicast DNS (mDNS) and DNS-SD</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-postgresql.html">5432,5433 - Pentesting Postgresql</a></li><li class="chapter-item "><a href="network-services-pentesting/5439-pentesting-redshift.html">5439 - Pentesting Redshift</a></li><li class="chapter-item "><a href="network-services-pentesting/5555-android-debug-bridge.html">5555 - Android Debug Bridge</a></li><li class="chapter-item "><a href="network-services-pentesting/5601-pentesting-kibana.html">5601 - Pentesting Kibana</a></li><li class="chapter-item "><a href="network-services-pentesting/5671-5672-pentesting-amqp.html">5671,5672 - Pentesting AMQP</a></li><li class="chapter-item "><a href="network-services-pentesting/pentesting-vnc.html">5800,5801,5900,5901 - Pentesting VNC</a></li><li class="chapter-item "><a href="network-services-pentesting/5984-pentesting-couchdb.html">5984,6984 - Pentesting CouchDB</a></li><li class="chapter-item "><a href="network-services-pentesting/5985-5986-pentesting-winrm.html">5985,5986 - Pentesting WinRM</a></li><li class="chapter-item "><a href="network-services-pentesting/5985-5986-pentesting-omi.html">5985,5986 - Pentesting OMI</a></li><li class="chapter-item "><a href="network-services-pentesting/6000-pentesting-x11.html">6000 - Pentesting X11</a></li><li class="chapter-item "><a href="network-services-pentesting/6379-pentesting-redis.html">6379 - Pentesting Redis</a></li><li class="chapter-item "><a href="network-services-pentesting/8009-pentesting-apache-jserv-protocol-ajp.html">8009 - Pentesting Apache JServ Protocol (AJP)</a></li><li class="chapter-item "><a href="network-services-pentesting/8086-pentesting-influxdb.html">8086 - Pentesting InfluxDB</a></li><li class="chapter-item "><a href="network-services-pentesting/8089-splunkd.html">8089 - Pentesting Splunkd</a></li><li class="chapter-item "><a href="network-services-pentesting/8333-18333-38333-18444-pentesting-bitcoin.html">8333,18333,38333,18444 - Pentesting Bitcoin</a></li><li class="chapter-item "><a href="network-services-pentesting/9000-pentesting-fastcgi.html">9000 - Pentesting FastCGI</a></li><li class="chapter-item "><a href="network-services-pentesting/9001-pentesting-hsqldb.html">9001 - Pentesting HSQLDB</a></li><li class="chapter-item "><a href="network-services-pentesting/cassandra.html">9042/9160 - Pentesting Cassandra</a></li><li class="chapter-item "><a href="network-services-pentesting/9100-pjl.html">9100 - Pentesting Raw Printing (JetDirect, AppSocket, PDL-datastream)</a></li><li class="chapter-item "><a href="network-services-pentesting/9200-pentesting-elasticsearch.html">9200 - Pentesting Elasticsearch</a></li><li class="chapter-item "><a href="network-services-pentesting/10000-network-data-management-protocol-ndmp.html">10000 - Pentesting Network Data Management Protocol (ndmp)</a></li><li class="chapter-item "><a href="network-services-pentesting/11211-memcache/index.html">11211 - Pentesting Memcache</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="network-services-pentesting/11211-memcache/memcache-commands.html">Memcache Commands</a></li></ol></li><li class="chapter-item "><a href="network-services-pentesting/15672-pentesting-rabbitmq-management.html">15672 - Pentesting RabbitMQ Management</a></li><li class="chapter-item "><a href="network-services-pentesting/24007-24008-24009-49152-pentesting-glusterfs.html">24007,24008,24009,49152 - Pentesting GlusterFS</a></li><li class="chapter-item "><a href="network-services-pentesting/27017-27018-mongodb.html">27017,27018 - Pentesting MongoDB</a></li><li class="chapter-item "><a href="network-services-pentesting/44134-pentesting-tiller-helm.html">44134 - Pentesting Tiller (Helm)</a></li><li class="chapter-item "><a href="network-services-pentesting/44818-ethernetip.html">44818/UDP/TCP - Pentesting EthernetIP</a></li><li class="chapter-item "><a href="network-services-pentesting/47808-udp-bacnet.html">47808/udp - Pentesting BACNet</a></li><li class="chapter-item "><a href="network-services-pentesting/50030-50060-50070-50075-50090-pentesting-hadoop.html">50030,50060,50070,50075,50090 - Pentesting Hadoop</a></li><li class="chapter-item affix "><li class="part-title">🕸️ Pentesting Web</li><li class="chapter-item "><a href="pentesting-web/web-vulnerabilities-methodology.html">Web Vulnerabilities Methodology</a></li><li class="chapter-item "><a href="pentesting-web/pocs-and-polygloths-cheatsheet/index.html">Reflecting Techniques - PoCs and Polygloths CheatSheet</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/pocs-and-polygloths-cheatsheet/web-vulns-list.html">Web Vulns List</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/2fa-bypass.html">2FA/MFA/OTP Bypass</a></li><li class="chapter-item "><a href="pentesting-web/account-takeover.html">Account Takeover</a></li><li class="chapter-item "><a href="pentesting-web/browser-extension-pentesting-methodology/index.html">Browser Extension Pentesting Methodology</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/browser-extension-pentesting-methodology/browext-clickjacking.html">BrowExt - ClickJacking</a></li><li class="chapter-item "><a href="pentesting-web/browser-extension-pentesting-methodology/browext-permissions-and-host_permissions.html">BrowExt - permissions &amp; host_permissions</a></li><li class="chapter-item "><a href="pentesting-web/browser-extension-pentesting-methodology/browext-xss-example.html">BrowExt - XSS Example</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/bypass-payment-process.html">Bypass Payment Process</a></li><li class="chapter-item "><a href="pentesting-web/captcha-bypass.html">Captcha Bypass</a></li><li class="chapter-item "><a href="pentesting-web/cache-deception/index.html">Cache Poisoning and Cache Deception</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/cache-deception/cache-poisoning-via-url-discrepancies.html">Cache Poisoning via URL discrepancies</a></li><li class="chapter-item "><a href="pentesting-web/cache-deception/cache-poisoning-to-dos.html">Cache Poisoning to DoS</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/clickjacking.html">Clickjacking</a></li><li class="chapter-item "><a href="pentesting-web/client-side-template-injection-csti.html">Client Side Template Injection (CSTI)</a></li><li class="chapter-item "><a href="pentesting-web/client-side-path-traversal.html">Client Side Path Traversal</a></li><li class="chapter-item "><a href="pentesting-web/command-injection.html">Command Injection</a></li><li class="chapter-item "><a href="pentesting-web/content-security-policy-csp-bypass/index.html">Content Security Policy (CSP) Bypass</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/content-security-policy-csp-bypass/csp-bypass-self-+-unsafe-inline-with-iframes.html">CSP bypass: self + &#39;unsafe-inline&#39; with Iframes</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/hacking-with-cookies/index.html">Cookies Hacking</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/hacking-with-cookies/cookie-tossing.html">Cookie Tossing</a></li><li class="chapter-item "><a href="pentesting-web/hacking-with-cookies/cookie-jar-overflow.html">Cookie Jar Overflow</a></li><li class="chapter-item "><a href="pentesting-web/hacking-with-cookies/cookie-bomb.html">Cookie Bomb</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/cors-bypass.html">CORS - Misconfigurations &amp; Bypass</a></li><li class="chapter-item "><a href="pentesting-web/crlf-0d-0a.html">CRLF (%0D%0A) Injection</a></li><li class="chapter-item "><a href="pentesting-web/csrf-cross-site-request-forgery.html">CSRF (Cross Site Request Forgery)</a></li><li class="chapter-item "><a href="pentesting-web/dangling-markup-html-scriptless-injection/index.html">Dangling Markup - HTML scriptless injection</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/dangling-markup-html-scriptless-injection/ss-leaks.html">SS-Leaks</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/dependency-confusion.html">Dependency Confusion</a></li><li class="chapter-item "><a href="pentesting-web/deserialization/index.html">Deserialization</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/deserialization/nodejs-proto-prototype-pollution/index.html">NodeJS - __proto__ &amp; prototype Pollution</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/deserialization/nodejs-proto-prototype-pollution/client-side-prototype-pollution.html">Client Side Prototype Pollution</a></li><li class="chapter-item "><a href="pentesting-web/deserialization/nodejs-proto-prototype-pollution/express-prototype-pollution-gadgets.html">Express Prototype Pollution Gadgets</a></li><li class="chapter-item "><a href="pentesting-web/deserialization/nodejs-proto-prototype-pollution/prototype-pollution-to-rce.html">Prototype Pollution to RCE</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/deserialization/java-jsf-viewstate-.faces-deserialization.html">Java JSF ViewState (.faces) Deserialization</a></li><li class="chapter-item "><a href="pentesting-web/deserialization/java-dns-deserialization-and-gadgetprobe.html">Java DNS Deserialization, GadgetProbe and Java Deserialization Scanner</a></li><li class="chapter-item "><a href="pentesting-web/deserialization/basic-java-deserialization-objectinputstream-readobject.html">Basic Java Deserialization (ObjectInputStream, readObject)</a></li><li class="chapter-item "><a href="pentesting-web/deserialization/php-deserialization-+-autoload-classes.html">PHP - Deserialization + Autoload Classes</a></li><li class="chapter-item "><a href="pentesting-web/deserialization/java-transformers-to-rutime-exec-payload.html">CommonsCollection1 Payload - Java Transformers to Rutime exec() and Thread Sleep</a></li><li class="chapter-item "><a href="pentesting-web/deserialization/basic-.net-deserialization-objectdataprovider-gadgets-expandedwrapper-and-json.net.html">Basic .Net deserialization (ObjectDataProvider gadget, ExpandedWrapper, and Json.Net)</a></li><li class="chapter-item "><a href="pentesting-web/deserialization/exploiting-__viewstate-knowing-the-secret.html">Exploiting __VIEWSTATE knowing the secrets</a></li><li class="chapter-item "><a href="pentesting-web/deserialization/exploiting-__viewstate-parameter.html">Exploiting __VIEWSTATE without knowing the secrets</a></li><li class="chapter-item "><a href="pentesting-web/deserialization/python-yaml-deserialization.html">Python Yaml Deserialization</a></li><li class="chapter-item "><a href="pentesting-web/deserialization/jndi-java-naming-and-directory-interface-and-log4shell.html">JNDI - Java Naming and Directory Interface &amp; Log4Shell</a></li><li class="chapter-item "><a href="pentesting-web/deserialization/ruby-class-pollution.html">Ruby Class Pollution</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/domain-subdomain-takeover.html">Domain/Subdomain takeover</a></li><li class="chapter-item "><a href="pentesting-web/email-injections.html">Email Injections</a></li><li class="chapter-item "><a href="pentesting-web/file-inclusion/index.html">File Inclusion/Path traversal</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/file-inclusion/phar-deserialization.html">phar:// deserialization</a></li><li class="chapter-item "><a href="pentesting-web/file-inclusion/lfi2rce-via-php-filters.html">LFI2RCE via PHP Filters</a></li><li class="chapter-item "><a href="pentesting-web/file-inclusion/lfi2rce-via-nginx-temp-files.html">LFI2RCE via Nginx temp files</a></li><li class="chapter-item "><a href="pentesting-web/file-inclusion/via-php_session_upload_progress.html">LFI2RCE via PHP_SESSION_UPLOAD_PROGRESS</a></li><li class="chapter-item "><a href="pentesting-web/file-inclusion/lfi2rce-via-segmentation-fault.html">LFI2RCE via Segmentation Fault</a></li><li class="chapter-item "><a href="pentesting-web/file-inclusion/lfi2rce-via-phpinfo.html">LFI2RCE via phpinfo()</a></li><li class="chapter-item "><a href="pentesting-web/file-inclusion/lfi2rce-via-temp-file-uploads.html">LFI2RCE Via temp file uploads</a></li><li class="chapter-item "><a href="pentesting-web/file-inclusion/lfi2rce-via-eternal-waiting.html">LFI2RCE via Eternal waiting</a></li><li class="chapter-item "><a href="pentesting-web/file-inclusion/lfi2rce-via-compress.zlib-+-php_stream_prefer_studio-+-path-disclosure.html">LFI2RCE Via compress.zlib + PHP_STREAM_PREFER_STUDIO + Path Disclosure</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/file-upload/index.html">File Upload</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/file-upload/pdf-upload-xxe-and-cors-bypass.html">PDF Upload - XXE and CORS bypass</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/formula-csv-doc-latex-ghostscript-injection.html">Formula/CSV/Doc/LaTeX/GhostScript Injection</a></li><li class="chapter-item "><a href="pentesting-web/grpc-web-pentest.html">gRPC-Web Pentest</a></li><li class="chapter-item "><a href="pentesting-web/http-connection-contamination.html">HTTP Connection Contamination</a></li><li class="chapter-item "><a href="pentesting-web/http-connection-request-smuggling.html">HTTP Connection Request Smuggling</a></li><li class="chapter-item "><a href="pentesting-web/http-request-smuggling/index.html">HTTP Request Smuggling / HTTP Desync Attack</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/http-request-smuggling/browser-http-request-smuggling.html">Browser HTTP Request Smuggling</a></li><li class="chapter-item "><a href="pentesting-web/http-request-smuggling/request-smuggling-in-http-2-downgrades.html">Request Smuggling in HTTP/2 Downgrades</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/http-response-smuggling-desync.html">HTTP Response Smuggling / Desync</a></li><li class="chapter-item "><a href="pentesting-web/h2c-smuggling.html">Upgrade Header Smuggling</a></li><li class="chapter-item "><a href="pentesting-web/abusing-hop-by-hop-headers.html">hop-by-hop headers</a></li><li class="chapter-item "><a href="pentesting-web/idor.html">IDOR</a></li><li class="chapter-item "><a href="pentesting-web/hacking-jwt-json-web-tokens.html">JWT Vulnerabilities (Json Web Tokens)</a></li><li class="chapter-item "><a href="pentesting-web/ldap-injection.html">LDAP Injection</a></li><li class="chapter-item "><a href="pentesting-web/login-bypass/index.html">Login Bypass</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/login-bypass/sql-login-bypass.html">Login bypass List</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/nosql-injection.html">NoSQL injection</a></li><li class="chapter-item "><a href="pentesting-web/oauth-to-account-takeover.html">OAuth to Account takeover</a></li><li class="chapter-item "><a href="pentesting-web/open-redirect.html">Open Redirect</a></li><li class="chapter-item "><a href="pentesting-web/orm-injection.html">ORM Injection</a></li><li class="chapter-item "><a href="pentesting-web/parameter-pollution.html">Parameter Pollution | JSON Injection</a></li><li class="chapter-item "><a href="pentesting-web/phone-number-injections.html">Phone Number Injections</a></li><li class="chapter-item "><a href="pentesting-web/postmessage-vulnerabilities/index.html">PostMessage Vulnerabilities</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/postmessage-vulnerabilities/blocking-main-page-to-steal-postmessage.html">Blocking main page to steal postmessage</a></li><li class="chapter-item "><a href="pentesting-web/postmessage-vulnerabilities/bypassing-sop-with-iframes-1.html">Bypassing SOP with Iframes - 1</a></li><li class="chapter-item "><a href="pentesting-web/postmessage-vulnerabilities/bypassing-sop-with-iframes-2.html">Bypassing SOP with Iframes - 2</a></li><li class="chapter-item "><a href="pentesting-web/postmessage-vulnerabilities/steal-postmessage-modifying-iframe-location.html">Steal postmessage modifying iframe location</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/proxy-waf-protections-bypass.html">Proxy / WAF Protections Bypass</a></li><li class="chapter-item "><a href="pentesting-web/race-condition.html">Race Condition</a></li><li class="chapter-item "><a href="pentesting-web/rate-limit-bypass.html">Rate Limit Bypass</a></li><li class="chapter-item "><a href="pentesting-web/registration-vulnerabilities.html">Registration &amp; Takeover Vulnerabilities</a></li><li class="chapter-item "><a href="pentesting-web/regular-expression-denial-of-service-redos.html">Regular expression Denial of Service - ReDoS</a></li><li class="chapter-item "><a href="pentesting-web/reset-password.html">Reset/Forgotten Password Bypass</a></li><li class="chapter-item "><a href="pentesting-web/reverse-tab-nabbing.html">Reverse Tab Nabbing</a></li><li class="chapter-item "><a href="pentesting-web/saml-attacks/index.html">SAML Attacks</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/saml-attacks/saml-basics.html">SAML Basics</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/server-side-inclusion-edge-side-inclusion-injection.html">Server Side Inclusion/Edge Side Inclusion Injection</a></li><li class="chapter-item "><a href="pentesting-web/sql-injection/index.html">SQL Injection</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/sql-injection/ms-access-sql-injection.html">MS Access SQL Injection</a></li><li class="chapter-item "><a href="pentesting-web/sql-injection/mssql-injection.html">MSSQL Injection</a></li><li class="chapter-item "><a href="pentesting-web/sql-injection/mysql-injection/index.html">MySQL injection</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/sql-injection/mysql-injection/mysql-ssrf.html">MySQL File priv to SSRF/RCE</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/sql-injection/oracle-injection.html">Oracle injection</a></li><li class="chapter-item "><a href="pentesting-web/sql-injection/cypher-injection-neo4j.html">Cypher Injection (neo4j)</a></li><li class="chapter-item "><a href="pentesting-web/sql-injection/postgresql-injection/index.html">PostgreSQL injection</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/sql-injection/postgresql-injection/dblink-lo_import-data-exfiltration.html">dblink/lo_import data exfiltration</a></li><li class="chapter-item "><a href="pentesting-web/sql-injection/postgresql-injection/pl-pgsql-password-bruteforce.html">PL/pgSQL Password Bruteforce</a></li><li class="chapter-item "><a href="pentesting-web/sql-injection/postgresql-injection/network-privesc-port-scanner-and-ntlm-chanllenge-response-disclosure.html">Network - Privesc, Port Scanner and NTLM chanllenge response disclosure</a></li><li class="chapter-item "><a href="pentesting-web/sql-injection/postgresql-injection/big-binary-files-upload-postgresql.html">Big Binary Files Upload (PostgreSQL)</a></li><li class="chapter-item "><a href="pentesting-web/sql-injection/postgresql-injection/rce-with-postgresql-languages.html">RCE with PostgreSQL Languages</a></li><li class="chapter-item "><a href="pentesting-web/sql-injection/postgresql-injection/rce-with-postgresql-extensions.html">RCE with PostgreSQL Extensions</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/sql-injection/sqlmap/index.html">SQLMap - CheatSheet</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/sql-injection/sqlmap/second-order-injection-sqlmap.html">Second Order Injection - SQLMap</a></li></ol></li></ol></li><li class="chapter-item "><a href="pentesting-web/ssrf-server-side-request-forgery/index.html">SSRF (Server Side Request Forgery)</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/ssrf-server-side-request-forgery/url-format-bypass.html">URL Format Bypass</a></li><li class="chapter-item "><a href="pentesting-web/ssrf-server-side-request-forgery/ssrf-vulnerable-platforms.html">SSRF Vulnerable Platforms</a></li><li class="chapter-item "><a href="pentesting-web/ssrf-server-side-request-forgery/cloud-ssrf.html">Cloud SSRF</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/ssti-server-side-template-injection/index.html">SSTI (Server Side Template Injection)</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/ssti-server-side-template-injection/el-expression-language.html">EL - Expression Language</a></li><li class="chapter-item "><a href="pentesting-web/ssti-server-side-template-injection/jinja2-ssti.html">Jinja2 SSTI</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/timing-attacks.html">Timing Attacks</a></li><li class="chapter-item "><a href="pentesting-web/unicode-injection/index.html">Unicode Injection</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/unicode-injection/unicode-normalization.html">Unicode Normalization</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/uuid-insecurities.html">UUID Insecurities</a></li><li class="chapter-item "><a href="pentesting-web/websocket-attacks.html">WebSocket Attacks</a></li><li class="chapter-item "><a href="pentesting-web/web-tool-wfuzz.html">Web Tool - WFuzz</a></li><li class="chapter-item "><a href="pentesting-web/xpath-injection.html">XPATH injection</a></li><li class="chapter-item "><a href="pentesting-web/xslt-server-side-injection-extensible-stylesheet-language-transformations.html">XSLT Server Side Injection (Extensible Stylesheet Language Transformations)</a></li><li class="chapter-item "><a href="pentesting-web/xxe-xee-xml-external-entity.html">XXE - XEE - XML External Entity</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/index.html">XSS (Cross Site Scripting)</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/abusing-service-workers.html">Abusing Service Workers</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/chrome-cache-to-xss.html">Chrome Cache to XSS</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/debugging-client-side-js.html">Debugging Client Side JS</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/dom-clobbering.html">Dom Clobbering</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/dom-invader.html">DOM Invader</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/dom-xss.html">DOM XSS</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/iframes-in-xss-and-csp.html">Iframes in XSS, CSP and SOP</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/integer-overflow.html">Integer Overflow</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/js-hoisting.html">JS Hoisting</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/other-js-tricks.html">Misc JS Tricks &amp; Relevant Info</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/pdf-injection.html">PDF Injection</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/server-side-xss-dynamic-pdf.html">Server Side XSS (Dynamic PDF)</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/shadow-dom.html">Shadow DOM</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/some-same-origin-method-execution.html">SOME - Same Origin Method Execution</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/sniff-leak.html">Sniff Leak</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/steal-info-js.html">Steal Info JS</a></li><li class="chapter-item "><a href="pentesting-web/xss-cross-site-scripting/xss-in-markdown.html">XSS in Markdown</a></li></ol></li><li class="chapter-item "><a href="pentesting-web/xssi-cross-site-script-inclusion.html">XSSI (Cross-Site Script Inclusion)</a></li><li class="chapter-item "><a href="pentesting-web/xs-search/index.html">XS-Search/XS-Leaks</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/xs-search/connection-pool-example.html">Connection Pool Examples</a></li><li class="chapter-item "><a href="pentesting-web/xs-search/connection-pool-by-destination-example.html">Connection Pool by Destination Example</a></li><li class="chapter-item "><a href="pentesting-web/xs-search/cookie-bomb-+-onerror-xs-leak.html">Cookie Bomb + Onerror XS Leak</a></li><li class="chapter-item "><a href="pentesting-web/xs-search/url-max-length-client-side.html">URL Max Length - Client Side</a></li><li class="chapter-item "><a href="pentesting-web/xs-search/performance.now-example.html">performance.now example</a></li><li class="chapter-item "><a href="pentesting-web/xs-search/performance.now-+-force-heavy-task.html">performance.now + Force heavy task</a></li><li class="chapter-item "><a href="pentesting-web/xs-search/event-loop-blocking-+-lazy-images.html">Event Loop Blocking + Lazy images</a></li><li class="chapter-item "><a href="pentesting-web/xs-search/javascript-execution-xs-leak.html">JavaScript Execution XS Leak</a></li><li class="chapter-item "><a href="pentesting-web/xs-search/css-injection/index.html">CSS Injection</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="pentesting-web/xs-search/css-injection/css-injection-code.html">CSS Injection Code</a></li></ol></li></ol></li><li class="chapter-item "><a href="pentesting-web/iframe-traps.html">Iframe Traps</a></li><li class="chapter-item affix "><li class="part-title">⛈️ Cloud Security</li><li class="chapter-item "><div>Pentesting Kubernetes$$external:https://cloud.hacktricks.wiki/en/pentesting-cloud/kubernetes-security/index.html$$</div></li><li class="chapter-item "><div>Pentesting Cloud (AWS, GCP, Az...)$$external:https://cloud.hacktricks.wiki/en/pentesting-cloud/pentesting-cloud-methodology.html$$</div></li><li class="chapter-item "><div>Pentesting CI/CD (Github, Jenkins, Terraform...)$$external:https://cloud.hacktricks.wiki/en/pentesting-ci-cd/pentesting-ci-cd-methodology.html$$</div></li><li class="chapter-item affix "><li class="part-title">😎 Hardware/Physical Access</li><li class="chapter-item "><a href="hardware-physical-access/physical-attacks.html">Physical Attacks</a></li><li class="chapter-item "><a href="hardware-physical-access/escaping-from-gui-applications.html">Escaping from KIOSKs</a></li><li class="chapter-item "><a href="hardware-physical-access/firmware-analysis/index.html">Firmware Analysis</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="hardware-physical-access/firmware-analysis/bootloader-testing.html">Bootloader testing</a></li><li class="chapter-item "><a href="hardware-physical-access/firmware-analysis/firmware-integrity.html">Firmware Integrity</a></li></ol></li><li class="chapter-item "><li class="part-title">🎯 Binary Exploitation</li><li class="chapter-item "><a href="binary-exploitation/basic-stack-binary-exploitation-methodology/index.html">Basic Stack Binary Exploitation Methodology</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/basic-stack-binary-exploitation-methodology/elf-tricks.html">ELF Basic Information</a></li><li class="chapter-item "><a href="binary-exploitation/basic-stack-binary-exploitation-methodology/tools/index.html">Exploiting Tools</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/basic-stack-binary-exploitation-methodology/tools/pwntools.html">PwnTools</a></li></ol></li></ol></li><li class="chapter-item "><a href="binary-exploitation/stack-overflow/index.html">Stack Overflow</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/stack-overflow/pointer-redirecting.html">Pointer Redirecting</a></li><li class="chapter-item "><a href="binary-exploitation/stack-overflow/ret2win/index.html">Ret2win</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/stack-overflow/ret2win/ret2win-arm64.html">Ret2win - arm64</a></li></ol></li><li class="chapter-item "><a href="binary-exploitation/stack-overflow/stack-shellcode/index.html">Stack Shellcode</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/stack-overflow/stack-shellcode/stack-shellcode-arm64.html">Stack Shellcode - arm64</a></li></ol></li><li class="chapter-item "><a href="binary-exploitation/stack-overflow/stack-pivoting-ebp2ret-ebp-chaining.html">Stack Pivoting - EBP2Ret - EBP chaining</a></li><li class="chapter-item "><a href="binary-exploitation/stack-overflow/uninitialized-variables.html">Uninitialized Variables</a></li></ol></li><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/index.html">ROP - Return Oriented Programing</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/brop-blind-return-oriented-programming.html">BROP - Blind Return Oriented Programming</a></li><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/ret2csu.html">Ret2csu</a></li><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/ret2dlresolve.html">Ret2dlresolve</a></li><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/ret2esp-ret2reg.html">Ret2esp / Ret2reg</a></li><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/ret2lib/index.html">Ret2lib</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/ret2lib/rop-leaking-libc-address/index.html">Leaking libc address with ROP</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/ret2lib/rop-leaking-libc-address/rop-leaking-libc-template.html">Leaking libc - template</a></li></ol></li><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/ret2lib/one-gadget.html">One Gadget</a></li><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/ret2lib/ret2lib-+-printf-leak-arm64.html">Ret2lib + Printf leak - arm64</a></li></ol></li><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/rop-syscall-execv/index.html">Ret2syscall</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/rop-syscall-execv/ret2syscall-arm64.html">Ret2syscall - ARM64</a></li></ol></li><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/ret2vdso.html">Ret2vDSO</a></li><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/srop-sigreturn-oriented-programming/index.html">SROP - Sigreturn-Oriented Programming</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/rop-return-oriented-programing/srop-sigreturn-oriented-programming/srop-arm64.html">SROP - ARM64</a></li></ol></li></ol></li><li class="chapter-item "><a href="binary-exploitation/array-indexing.html">Array Indexing</a></li><li class="chapter-item "><a href="binary-exploitation/integer-overflow.html">Integer Overflow</a></li><li class="chapter-item "><a href="binary-exploitation/format-strings/index.html">Format Strings</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/format-strings/format-strings-arbitrary-read-example.html">Format Strings - Arbitrary Read Example</a></li><li class="chapter-item "><a href="binary-exploitation/format-strings/format-strings-template.html">Format Strings Template</a></li></ol></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/index.html">Libc Heap</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/libc-heap/bins-and-memory-allocations.html">Bins &amp; Memory Allocations</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/heap-memory-functions/index.html">Heap Memory Functions</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/libc-heap/heap-memory-functions/free.html">free</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/heap-memory-functions/malloc-and-sysmalloc.html">malloc &amp; sysmalloc</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/heap-memory-functions/unlink.html">unlink</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/heap-memory-functions/heap-functions-security-checks.html">Heap Functions Security Checks</a></li></ol></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/use-after-free/index.html">Use After Free</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/libc-heap/use-after-free/first-fit.html">First Fit</a></li></ol></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/double-free.html">Double Free</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/overwriting-a-freed-chunk.html">Overwriting a freed chunk</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/heap-overflow.html">Heap Overflow</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/unlink-attack.html">Unlink Attack</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/fast-bin-attack.html">Fast Bin Attack</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/unsorted-bin-attack.html">Unsorted Bin Attack</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/large-bin-attack.html">Large Bin Attack</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/tcache-bin-attack.html">Tcache Bin Attack</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/off-by-one-overflow.html">Off by one overflow</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/house-of-spirit.html">House of Spirit</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/house-of-lore.html">House of Lore | Small bin Attack</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/house-of-einherjar.html">House of Einherjar</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/house-of-force.html">House of Force</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/house-of-orange.html">House of Orange</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/house-of-rabbit.html">House of Rabbit</a></li><li class="chapter-item "><a href="binary-exploitation/libc-heap/house-of-roman.html">House of Roman</a></li></ol></li><li class="chapter-item "><a href="binary-exploitation/common-binary-protections-and-bypasses/index.html">Common Binary Exploitation Protections &amp; Bypasses</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/common-binary-protections-and-bypasses/aslr/index.html">ASLR</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/common-binary-protections-and-bypasses/aslr/ret2plt.html">Ret2plt</a></li><li class="chapter-item "><a href="binary-exploitation/common-binary-protections-and-bypasses/aslr/ret2ret.html">Ret2ret &amp; Reo2pop</a></li></ol></li><li class="chapter-item "><a href="binary-exploitation/common-binary-protections-and-bypasses/cet-and-shadow-stack.html">CET &amp; Shadow Stack</a></li><li class="chapter-item "><a href="binary-exploitation/common-binary-protections-and-bypasses/libc-protections.html">Libc Protections</a></li><li class="chapter-item "><a href="binary-exploitation/common-binary-protections-and-bypasses/memory-tagging-extension-mte.html">Memory Tagging Extension (MTE)</a></li><li class="chapter-item "><a href="binary-exploitation/common-binary-protections-and-bypasses/no-exec-nx.html">No-exec / NX</a></li><li class="chapter-item "><a href="binary-exploitation/common-binary-protections-and-bypasses/pie/index.html">PIE</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/common-binary-protections-and-bypasses/pie/bypassing-canary-and-pie.html">BF Addresses in the Stack</a></li></ol></li><li class="chapter-item "><a href="binary-exploitation/common-binary-protections-and-bypasses/relro.html">Relro</a></li><li class="chapter-item "><a href="binary-exploitation/common-binary-protections-and-bypasses/stack-canaries/index.html">Stack Canaries</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/common-binary-protections-and-bypasses/stack-canaries/bf-forked-stack-canaries.html">BF Forked &amp; Threaded Stack Canaries</a></li><li class="chapter-item "><a href="binary-exploitation/common-binary-protections-and-bypasses/stack-canaries/print-stack-canary.html">Print Stack Canary</a></li></ol></li></ol></li><li class="chapter-item "><a href="binary-exploitation/arbitrary-write-2-exec/index.html">Write What Where 2 Exec</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="binary-exploitation/arbitrary-write-2-exec/www2exec-atexit.html">WWW2Exec - atexit()</a></li><li class="chapter-item "><a href="binary-exploitation/arbitrary-write-2-exec/www2exec-.dtors-and-.fini_array.html">WWW2Exec - .dtors &amp; .fini_array</a></li><li class="chapter-item "><a href="binary-exploitation/arbitrary-write-2-exec/aw2exec-got-plt.html">WWW2Exec - GOT/PLT</a></li><li class="chapter-item "><a href="binary-exploitation/arbitrary-write-2-exec/aw2exec-__malloc_hook.html">WWW2Exec - __malloc_hook &amp; __free_hook</a></li></ol></li><li class="chapter-item "><a href="binary-exploitation/common-exploiting-problems.html">Common Exploiting Problems</a></li><li class="chapter-item "><a href="binary-exploitation/windows-exploiting-basic-guide-oscp-lvl.html">Windows Exploiting (Basic Guide - OSCP lvl)</a></li><li class="chapter-item "><a href="binary-exploitation/ios-exploiting.html">iOS Exploiting</a></li><li class="chapter-item affix "><li class="part-title">🔩 Reversing</li><li class="chapter-item "><a href="reversing/reversing-tools-basic-methods/index.html">Reversing Tools &amp; Basic Methods</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="reversing/reversing-tools-basic-methods/angr/index.html">Angr</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="reversing/reversing-tools-basic-methods/angr/angr-examples.html">Angr - Examples</a></li></ol></li><li class="chapter-item "><a href="reversing/reversing-tools-basic-methods/satisfiability-modulo-theories-smt-z3.html">Z3 - Satisfiability Modulo Theories (SMT)</a></li><li class="chapter-item "><a href="reversing/reversing-tools-basic-methods/cheat-engine.html">Cheat Engine</a></li><li class="chapter-item "><a href="reversing/reversing-tools-basic-methods/blobrunner.html">Blobrunner</a></li></ol></li><li class="chapter-item "><a href="reversing/common-api-used-in-malware.html">Common API used in Malware</a></li><li class="chapter-item "><a href="reversing/word-macros.html">Word Macros</a></li><li class="chapter-item affix "><li class="part-title">🔮 Crypto &amp; Stego</li><li class="chapter-item "><a href="crypto-and-stego/cryptographic-algorithms/index.html">Cryptographic/Compression Algorithms</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="crypto-and-stego/cryptographic-algorithms/unpacking-binaries.html">Unpacking binaries</a></li></ol></li><li class="chapter-item "><a href="crypto-and-stego/certificates.html">Certificates</a></li><li class="chapter-item "><a href="crypto-and-stego/cipher-block-chaining-cbc-mac-priv.html">Cipher Block Chaining CBC-MAC</a></li><li class="chapter-item "><a href="crypto-and-stego/crypto-ctfs-tricks.html">Crypto CTFs Tricks</a></li><li class="chapter-item "><a href="crypto-and-stego/electronic-code-book-ecb.html">Electronic Code Book (ECB)</a></li><li class="chapter-item "><a href="crypto-and-stego/hash-length-extension-attack.html">Hash Length Extension Attack</a></li><li class="chapter-item "><a href="crypto-and-stego/padding-oracle-priv.html">Padding Oracle</a></li><li class="chapter-item "><a href="crypto-and-stego/rc4-encrypt-and-decrypt.html">RC4 - Encrypt&amp;Decrypt</a></li><li class="chapter-item "><a href="crypto-and-stego/stego-tricks.html">Stego Tricks</a></li><li class="chapter-item "><a href="crypto-and-stego/esoteric-languages.html">Esoteric languages</a></li><li class="chapter-item "><a href="crypto-and-stego/blockchain-and-crypto-currencies.html">Blockchain &amp; Crypto Currencies</a></li><li class="chapter-item affix "><li class="part-title">✍️ TODO</li><li class="chapter-item "><a href="todo/references.html">Other Big References</a></li><li class="chapter-item "><a href="todo/rust-basics.html">Rust Basics</a></li><li class="chapter-item "><a href="todo/more-tools.html">More Tools</a></li><li class="chapter-item "><a href="todo/misc.html">MISC</a></li><li class="chapter-item "><a href="todo/pentesting-dns.html">Pentesting DNS</a></li><li class="chapter-item "><a href="todo/hardware-hacking/index.html">Hardware Hacking</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="todo/hardware-hacking/i2c.html">I2C</a></li><li class="chapter-item "><a href="todo/hardware-hacking/uart.html">UART</a></li><li class="chapter-item "><a href="todo/hardware-hacking/radio.html">Radio</a></li><li class="chapter-item "><a href="todo/hardware-hacking/jtag.html">JTAG</a></li><li class="chapter-item "><a href="todo/hardware-hacking/spi.html">SPI</a></li></ol></li><li class="chapter-item "><a href="todo/industrial-control-systems-hacking/index.html">Industrial Control Systems Hacking</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="todo/industrial-control-systems-hacking/modbus.html">Modbus Protocol</a></li></ol></li><li class="chapter-item "><a href="todo/radio-hacking/index.html">Radio Hacking</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="todo/radio-hacking/pentesting-rfid.html">Pentesting RFID</a></li><li class="chapter-item "><a href="todo/radio-hacking/infrared.html">Infrared</a></li><li class="chapter-item "><a href="todo/radio-hacking/sub-ghz-rf.html">Sub-GHz RF</a></li><li class="chapter-item "><a href="todo/radio-hacking/ibutton.html">iButton</a></li><li class="chapter-item "><a href="todo/radio-hacking/flipper-zero/index.html">Flipper Zero</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="todo/radio-hacking/flipper-zero/fz-nfc.html">FZ - NFC</a></li><li class="chapter-item "><a href="todo/radio-hacking/flipper-zero/fz-sub-ghz.html">FZ - Sub-GHz</a></li><li class="chapter-item "><a href="todo/radio-hacking/flipper-zero/fz-infrared.html">FZ - Infrared</a></li><li class="chapter-item "><a href="todo/radio-hacking/flipper-zero/fz-ibutton.html">FZ - iButton</a></li><li class="chapter-item "><a href="todo/radio-hacking/flipper-zero/fz-125khz-rfid.html">FZ - 125kHz RFID</a></li></ol></li><li class="chapter-item "><a href="todo/radio-hacking/proxmark-3.html">Proxmark 3</a></li><li class="chapter-item "><a href="todo/radio-hacking/fissure-the-rf-framework.html">FISSURE - The RF Framework</a></li><li class="chapter-item "><a href="todo/radio-hacking/low-power-wide-area-network.html">Low-Power Wide Area Network</a></li><li class="chapter-item "><a href="todo/radio-hacking/pentesting-ble-bluetooth-low-energy.html">Pentesting BLE - Bluetooth Low Energy</a></li></ol></li><li class="chapter-item "><a href="todo/industrial-control-systems-hacking/index.html">Industrial Control Systems Hacking</a></li><li class="chapter-item "><a href="todo/test-llms.html">Test LLMs</a></li><li class="chapter-item "><a href="todo/llm-training-data-preparation/index.html">LLM Training</a><a class="toggle"><div>❱</div></a></li><li><ol class="section"><li class="chapter-item "><a href="todo/llm-training-data-preparation/0.-basic-llm-concepts.html">0. Basic LLM Concepts</a></li><li class="chapter-item "><a href="todo/llm-training-data-preparation/1.-tokenizing.html">1. Tokenizing</a></li><li class="chapter-item "><a href="todo/llm-training-data-preparation/2.-data-sampling.html">2. Data Sampling</a></li><li class="chapter-item "><a href="todo/llm-training-data-preparation/3.-token-embeddings.html">3. Token Embeddings</a></li><li class="chapter-item "><a href="todo/llm-training-data-preparation/4.-attention-mechanisms.html">4. Attention Mechanisms</a></li><li class="chapter-item "><a href="todo/llm-training-data-preparation/5.-llm-architecture.html">5. LLM Architecture</a></li><li class="chapter-item "><a href="todo/llm-training-data-preparation/6.-pre-training-and-loading-models.html">6. Pre-training &amp; Loading models</a></li><li class="chapter-item "><a href="todo/llm-training-data-preparation/7.0.-lora-improvements-in-fine-tuning.html">7.0. LoRA Improvements in fine-tuning</a></li><li class="chapter-item "><a href="todo/llm-training-data-preparation/7.1.-fine-tuning-for-classification.html">7.1. Fine-Tuning for Classification</a></li><li class="chapter-item "><a href="todo/llm-training-data-preparation/7.2.-fine-tuning-to-follow-instructions.html">7.2. Fine-Tuning to follow instructions</a></li></ol></li><li class="chapter-item "><a href="todo/burp-suite.html">Burp Suite</a></li><li class="chapter-item "><a href="todo/other-web-tricks.html">Other Web Tricks</a></li><li class="chapter-item "><div>Interesting HTTP$$external:todo/interesting-http.md$$</div></li><li class="chapter-item "><a href="todo/android-forensics.html">Android Forensics</a></li><li class="chapter-item "><a href="todo/tr-069.html">TR-069</a></li><li class="chapter-item "><a href="todo/6881-udp-pentesting-bittorrent.html">6881/udp - Pentesting BitTorrent</a></li><li class="chapter-item "><a href="todo/online-platforms-with-api.html">Online Platforms with API</a></li><li class="chapter-item "><a href="todo/stealing-sensitive-information-disclosure-from-a-web.html">Stealing Sensitive Information Disclosure from a Web</a></li><li class="chapter-item "><a href="todo/post-exploitation.html">Post Exploitation</a></li><li class="chapter-item "><a href="todo/investment-terms.html">Investment Terms</a></li><li class="chapter-item "><a href="todo/cookies-policy.html">Cookies Policy</a></li></ol>';
        toc = toc.replace(/<div>([^$<>]*)\$\$external:([^$<>]*)\$\$<\/div>/g, '<a class="external-link" href="$2">$1</a>') 
        this.innerHTML = toc
        // Set the current, active page, and reveal it if it's hidden
        let current_page = document.location.href.toString();
        if (current_page.endsWith("/")) {
            current_page += "index.html";
        }
        var links = Array.prototype.slice.call(this.querySelectorAll("a"));
        var l = links.length;
        for (var i = 0; i < l; ++i) {
            var link = links[i];
            var href = link.getAttribute("href");
            if (href && !href.startsWith("#") && !/^(?:[a-z+]+:)?\/\//.test(href)) {
                link.href = path_to_root + href;
            }
            // The "index" page is supposed to alias the first chapter in the book.
            if (link.href === current_page || (i === 0 && path_to_root === "" && current_page.endsWith("/index.html"))) {
                link.classList.add("active");
                var parent = link.parentElement;
                if (parent && parent.classList.contains("chapter-item")) {
                    parent.classList.add("expanded");
                }
                while (parent) {
                    if (parent.tagName === "LI" && parent.previousElementSibling) {
                        if (parent.previousElementSibling.classList.contains("chapter-item")) {
                            parent.previousElementSibling.classList.add("expanded");
                        }
                    }
                    parent = parent.parentElement;
                }
            }
        }
        // Track and set sidebar scroll position
        this.addEventListener('click', function(e) {
            if (e.target.tagName === 'A') {
                sessionStorage.setItem('sidebar-scroll', this.scrollTop);
            }
        }, { passive: true });
        var sidebarScrollTop = sessionStorage.getItem('sidebar-scroll');
        sessionStorage.removeItem('sidebar-scroll');
        if (sidebarScrollTop) {
            // preserve sidebar scroll position when navigating via links within sidebar
            this.scrollTop = sidebarScrollTop;
        } else {
            // scroll sidebar to current active section when navigating via "next/previous chapter" buttons
            var activeSection = document.querySelector('#sidebar .active');
            if (activeSection) {
                activeSection.scrollIntoView({ block: 'center' });
            }
        }
        // Toggle buttons
        var sidebarAnchorToggles = document.querySelectorAll('#sidebar a.toggle');
        function toggleSection(ev) {
            ev.currentTarget.parentElement.classList.toggle('expanded');
        }
        Array.from(sidebarAnchorToggles).forEach(function (el) {
            el.addEventListener('click', toggleSection);
        });
    }
}
window.customElements.define("mdbook-sidebar-scrollbox", MDBookSidebarScrollbox);